' O2CustTitle.inc
'  Includes for Custom Title bar
'  Need to add O2Common.inc before this
'  Updated Nov 24 2018

'  Note that in your program you need to set up the following parameters
'  at the beginning of the program
'  TitBarHt , TitBarColor, TitTxtColor , TitStr, AdjFacX,  MwWidth, MwTopleft 
'  and hTitBarFont  for example
'     hTitBarFont = O2ApiCreateFont("Tahoma", 15, FW_BOLD)
'  
'   And that upon exiting from the program in WM_CLOSE , you have to
'   place in  these codes
 '          IF hTitBarFont THEN
 '                        DeleteObject hTitBarFont
 '            END IF


'  for the custom title bar
  ' title bar height
   Long TitBarHt          
 ' title bar background  and text colour
   sys TitBarColor 
   sys TitTxtColor
'  title bar string
   string TitStr
' adjustment factor for the title bar x coord
   Long AdjFacX

 ' Main window width
  Long  MwWidth  
 ' Main window top left point        
  Long  MwTopleft      

'   for the custom Title bar font
   sys hTitBarFont  


  Declare  Sub PaintTitBar( sys hMainDlg )


'==================================
'  Draws the custom Title bar
Sub  PaintTitBar( sys hMainDlg)

    ' for the custom Title bar
    RECT TitBarRct
    PAINTSTRUCT  TitBar_Pst  
    sys hTitBarPen , hTitBarDC , hTitBarOld

    BeginPaint hMainDlg, VARPTR(TitBar_Pst)
                       hTitBarDC = GetDC(hMainDlg)
    
                        hTitBarPen = CreatePen(PS_SOLID,TitBarHt,TitBarColor)
                        hTitBarOld = SelectObject(hTitBarDC,hTitBarPen)

                   '    Draws the Title bar background
                  '      Note that AdjFacX is an arbitrary adjustment factor for the x coord
                 '       of the title bar to centralize the title
                        MoveToEx hTitBarDC,MwTopleft + AdjFacX , TitBarHt -10, 0
                        LineTo hTitBarDC,MwTopleft + MwWidth + AdjFacX, TitBarHt -10

                       SelectObject hTitBarDC,hTitBarOld
                       DeleteObject hTitBarPen


                      ' draw the title bar text 
                       SetBkMode hTitBarDC,   TRANSPARENT
                       SetTextColor hTitBarDC,  TitTxtColor    
                     '  Title text position rectangle
                       TitBarRct.left =   MwTopleft  + AdjFacX
                       TitBarRct.top  = 0
                       TitBarRct.right =   TitBarRct.left  + MwWidth
                       TitBarRct.bottom = TitBarHt
                       hTitBarOld = SelectObject( hTitBarDC, hTitBarFont)
                       DrawText  hTitBarDC,TitStr, -1, TitBarRct,  DT_SINGLELINE OR DT_CENTER OR DT_VCENTER
                       SelectObject  hTitBarDC, hTitBarOld
  
                       ReleaseDC hMainDlg, hTitBarDC
            EndPaint hMainDlg, VARPTR(TitBar_Pst)  
 End Sub




